﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Control.CheckForIllegalCrossThreadCalls = false;
            button1.Enabled = false;

            richTextBox1.BackColor = Color.Black;
            richTextBox1.ForeColor = Color.White;

            ThreadPool.QueueUserWorkItem((m) =>
            {
                ShowMessage("正在初始化...", false);
                _12306Class.GetMainPage(cookie: new CookieCollection());
                ShowMessage("完成");
                GetLoginImage();

                //  先获取车站信息
                var v = Stations.List;
            });

            Trains.TrainsChanged += Trains_TrainsChanged;
        }

        void Trains_TrainsChanged(object sender, List<Train> e)
        {
            checkedListBox2.Items.Clear();

            foreach (var train in e)
            {
                checkedListBox2.Items.Add(train.ToString());
            }
        }

        /// <summary>
        /// 获取登录验证码
        /// </summary>
        private void GetLoginImage()
        {
            ShowMessage("正在获取验证码...", false);
            ChangeOtherButton(false);
            button1.Enabled = false;
            button2.Enabled = false;

            Bitmap v = null;
            do
            {
                v = _12306Class.GetLoginImage();
            } while (v == null);
            pictureBox1.Image = v;

            button1.Enabled = true;
            button2.Enabled = true;

            ShowMessage("完成");
        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Threading.ThreadPool.QueueUserWorkItem((m) =>
                {
                    ShowMessage("正在登录...", false);
                    button1.Enabled = false;

                    var v = _12306Class.Login(textBox1.Text, textBox2.Text, textBox3.Text);
                    if (v.IsLogined)
                    {
                        GetFavoriteContacts();
                        ChangeOtherButton(true);

                        ShowMessage("成功");
                    }
                    else
                    {
                        MessageBox.Show(v.Message);
                        button1.Enabled = true;

                        if (v.type == ErrorType.VerificationError)
                        {
                            textBox3.Text = "";
                            GetLoginImage();
                        }
                        ShowMessage("失败");
                    }
                });
        }

        void ChangeOtherButton(bool enabled)
        {
            button3.Enabled = enabled;
            button4.Enabled = enabled;
            button5.Enabled = enabled;
            button6.Enabled = enabled;
        }

        /// <summary>
        /// 获取联系人信息
        /// </summary>
        private void GetFavoriteContacts()
        {
            checkedListBox1.Items.Clear();
            int count = 0;
            int pageSize = 7;
            int pageIndex = 0;
            ;
            do
            {
                List<Contact> contacts = _12306Class.GetFavoriteContacts(pageIndex, pageSize, out count);

                foreach (var contact in contacts)
                {
                    checkedListBox1.Items.Add(contact.ToString());
                }

            } while ((pageIndex + 1) * pageSize < count);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            GetLoginImage();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            GetFavoriteContacts();
        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            new CreateFavoriteContactFrom().ShowDialog();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            new GetTrainsFrom().ShowDialog();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < checkedListBox2.Items.Count; i++)
            {
                checkedListBox2.SetItemCheckState(i, CheckState.Checked);
            }
        }


        private void ShowMessage(string message, bool isNewLine = true)
        {
            this.Invoke(new Action<string, bool>((m, n) => { _ShowMessage(m, n); }), message, isNewLine);
      
        }   
        private void _ShowMessage(string message, bool isNewLine = true)
        {
            richTextBox1.AppendText(message);
            if (isNewLine)
            {
                richTextBox1.AppendText("\r\n");
            }

            richTextBox1.SelectionStart = richTextBox1.TextLength;
            richTextBox1.ScrollToCaret();
        }
    }
}
